<?php
/*
Plugin : Piwishadow
Plugin URI: http://binaryworld.hd.free.fr/
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

interface iModalOverlayLib {
	static public function getName();
	static public function isInstalled();
	public function getHrefThumbnailTemplate($gallery);
	public function getPlayerUrl();
	public function getFlashVarsTemplate();
	public function getDefaultLinkRelationship();
	public function appendHeaderContent($template, $tpl_var);
	public function getCloseThumbnailJavaScript();
}

class ShadowboxWrapper implements iModalOverlayLib {
	public static $LIB_NAME = 'shadowbox';
	
	static function getName() {
		return self::$LIB_NAME;
	}
	
	static public function isInstalled() {
		$filename = ModalOverlayLibFactory::getFactoryPath() .DS. self::getName() .DS. 'shadowbox.js';
		return file_exists($filename);
	}
	
	public function getHrefThumbnailTemplate($gallery) {
		// check swf media to add the support of the mp4, mov...
		$hrefModalOverlay = 'href="{$thumbnail.U_OVERLAY}" rel="{$thumbnail.REL_OVERLAY}['. $gallery .'];width={$thumbnail.VIDEO_WIDTH};height={$thumbnail.VIDEO_HEIGHT}{if isset($thumbnail.MEDIA) && $thumbnail.MEDIA != "swf"};player=flv;{literal}options={flashVars:{type:\'video\'}}{/literal}{/if}"';
		return $hrefModalOverlay;
	}
	
	public function getFlashVarsTemplate() {
		return 'file={$VIDEO_URL}&image={$SRC_IMG}&controlbar.position=over';
	}
	
	public function getPlayerUrl() {
		$path = ModalOverlayLibFactory::getFactoryUrl() .'/'. self::getName() .'/player.swf';
		return $path;
	}

	public function getDefaultLinkRelationship() {
		 return 'shadowbox';
	}
	
	public function appendHeaderContent($template, $tpl_var) {
		$libPath = ModalOverlayLibFactory::getFactoryUrl() .'/'. self::getName(); 
		
		$scriptContent = 'var PiwishadowOverlayWnd = Shadowbox; Shadowbox.init();';
		$headContent  = '<link rel="stylesheet" type="text/css" href="'. $libPath .'/shadowbox.css">';
		$headContent .= '<script type="text/javascript" src="'. $libPath .'/shadowbox.js"></script>';
		$headContent .= '<script type="text/javascript">'. $scriptContent .'</script>';
		
		$template->append($tpl_var, $headContent);
	}
	
	public function getCloseThumbnailJavaScript() {
		return 'parent.window.Shadowbox.close(); return false;';
	}
}

class MediaboxAdvancedWrapper implements iModalOverlayLib {
	public static $LIB_NAME = 'mediaboxAdvanced';

	static function getName() {
		return self::$LIB_NAME;
	}

	static public function isInstalled() {
		$filename = ModalOverlayLibFactory::getFactoryPath() .DS. self::getName() .DS. 'mediaboxAdv-1.3.4b.js';
		return file_exists($filename);
	}
	
	public function getHrefThumbnailTemplate($gallery) {
		//$hrefModalOverlay = 'href="{$thumbnail.U_OVERLAY}" rel="{$thumbnail.REL_OVERLAY}['. $gallery .'];width={$thumbnail.VIDEO_WIDTH};height={$thumbnail.VIDEO_HEIGHT}{if isset($thumbnail.MEDIA) && $thumbnail.MEDIA != "swf"};player=flv;{literal}options={flashVars:{type:\'video\'}}{/literal}{/if}"';
		$hrefModalOverlay = 'href="{$thumbnail.U_OVERLAY}" rel="{$thumbnail.REL_OVERLAY}['. $gallery .' {$thumbnail.VIDEO_WIDTH} {$thumbnail.VIDEO_HEIGHT}]"';
		return $hrefModalOverlay;
	}

	public function getFlashVarsTemplate() {
		return 'mediaURL={$VIDEO_URL}&teaserURL={$SRC_IMG}&allowSmoothing=true&autoPlay=false&buffer=6&showTimecode=true&loop=false&controlColor=0xFFFFFF&controlBackColor=0x000000&scaleIfFullScreen=true&showScalingButton=true&defaultVolume=100&crop=false';
	}
	
	public function getPlayerUrl() {
		$path = ModalOverlayLibFactory::getFactoryUrl() .'/'. self::getName() .'/NonverBlaster.swf';
		return $path;
	}
	
	public function getDefaultLinkRelationship() {
		return 'lightbox';
	}
	
	public function appendHeaderContent($template, $tpl_var) {
		$libPath = ModalOverlayLibFactory::getFactoryUrl() .'/'. self::getName(); 
		
		$headContent = '<link rel="stylesheet" href="'. $libPath .'/mediaboxAdvBlack21.css" type="text/css" media="screen" />';
		$headContent .= '<script src="'. $libPath .'/mootools-1.2.5-core-yc.js" type="text/javascript"></script>';
		$headContent .= '<script src="'. $libPath .'/Quickie.js" type="text/javascript"></script>';
		$headContent .= '<script type="text/javascript">var mediaboxAdvancedPath = "'. $libPath .'"</script>';
		$headContent .= '<script src="'. $libPath .'/mediaboxAdv-1.3.4b.js" type="text/javascript"></script>';
		$headContent .= '<script type="text/javascript">var PiwishadowOverlayWnd = Mediabox;</script>';
		
		$template->append($tpl_var, $headContent);
	}

	public function getCloseThumbnailJavaScript() {
		return 'parent.window.Shadowbox.close(); return false;';
	}
	
}


class ModalOverlayLibFactory {
	
	
	public static function getFactoryPath() {
		return dirname(__FILE__);
	}
	
	public static function getFactoryUrl() {
		return get_root_url() .'plugins/'. basename(dirname(__FILE__));
	}
	
	public static function getInstalledOverlayLibs() {
		$libs = array();
		if (MediaboxAdvancedWrapper::isInstalled() === true) $libs[] =  MediaboxAdvancedWrapper::getName();
		if (ShadowboxWrapper::isInstalled() === true) $libs[] =  ShadowboxWrapper::getName();
		return $libs;
	}
	
	public static function getDefaultOverlayLib() {
		return MediaboxAdvancedWrapper::getName();
	}
	
	public static function createModalOverlayLib($libName) {
		if (0 === strcmp($libName, MediaboxAdvancedWrapper::getName())) {
			return new MediaboxAdvancedWrapper();
		} else if (0 === strcmp($libName, ShadowboxWrapper::getName())) {
			return new ShadowboxWrapper();
		}
		return null;
	}
}

?>